apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ lool_name }}
  name: {{ lool_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ lool_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ lool_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ lool_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      annotations:
{% if k8s_flavor == 'openshift' %}
        openshift.io/scc: restricted-{{ lool_name }}
{% else %}
        kubernetes.io/psp: restricted-{{ lool_name }}
{% endif %}
      labels:
        name: {{ lool_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ lool_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ lool_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ lool_name }}
        - name: ADMIN_USERNAME
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ lool_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: LOOL_DOMAIN
          value: lool.{{ root_domain }}
        - name: LOOL_LOG_LEVEL
          value: {{ lool_log_level }}
        - name: NEXTCLOUD_DOMAIN
          value: cloud.{{ root_domain }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='libreofficeonline'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='libreofficeonline'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 15
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9980
        name: lool
        ports:
        - containerPort: 9980
        readinessProbe:
          httpGet:
            path: /
            port: 9980
            scheme: HTTPS
          initialDelaySeconds: 10
          periodSeconds: 10
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ lool_cpu_limit }}"
            memory: "{{ lool_memory_limit }}"
          requests:
            cpu: "{{ lool_cpu_request }}"
            memory: "{{ lool_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: true
          capabilities:
            add:
            - FOWNER
            - MKNOD
            - SYS_ADMIN
            - SYS_CHROOT
            drop:
            - KILL
            - SETGID
            - SETUID
        volumeMounts:
        - mountPath: /etc/loolwsd/server.crt
          name: certs
          subPath: tls.crt
        - mountPath: /etc/loolwsd/server.key
          name: certs
          subPath: tls.key
        - mountPath: /opt/lool/child-roots
          name: data
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ lool_name }}
{% else %}
      serviceAccountName: default
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ libreoffice_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: certs
        secret:
          secretName: {{ lool_name }}-cert
      - emptyDir: {}
        name: data
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='libreofficeonline'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - lool
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='libreofficeonline'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
